<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2006 pragmaMx Dev Team - http://pragmaMx.org
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * $Source: /home/www/dps3311/home/cvsroot/pragmamx/pragmamx_01/modules/News/categories.php,v $
 * $Revision: 1.7 $
 * $Author: tora60 $
 * $Date: 2007/03/24 12:38:47 $
 */

if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");

if (isset($_GET['catid'])) {
    $catid = intval($_GET['catid']);
} 
if (empty($catid)) {
    include(dirname(__FILE__) . '/index.php');
    exit;
} 
// rechte Blcke an oder aus
$index = 1;

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);
include_once("includes/mxNewsFunctions.php");
// ###################################
function newscatindex($catid)
{
    global $prefix, $pagetitle;
    if (isset($_GET['pagenum'])) {
        $pagenum = intval($_GET['pagenum']);
    } 
    if (empty($pagenum)) {
        $pagenum = 1;
    } 
    $catid = intval($catid);
    $pagecols = (empty($GLOBALS["storyhome_cols"])) ? 1 : intval($GLOBALS["storyhome_cols"]);
    if ($GLOBALS["multilingual"] == 1) {
        if (ereg("german", $GLOBALS["currentlang"])) $thislang = "german";
        else $thislang = $GLOBALS["currentlang"];
        $where[] = "(s.alanguage LIKE '" . $thislang . "%' OR s.alanguage='')";
    } 
    $where[] = "(s.catid = " . $catid . ") ";
    $where[] = "(s.time <= now())";
    $where = implode(' AND ', $where);
    $qry = "SELECT Count(sid) FROM ${prefix}_stories AS s WHERE " . $where;
    $result = sql_query($qry);
    list($allstories) = sql_fetch_row($result);
    if (MX_IS_USER) {
        $userinfo = mxGetUserData();
        $storynum = (empty($userinfo['storynum'])) ? $GLOBALS["storyhome"] : $userinfo['storynum'];
    } else {
        $storynum = $GLOBALS["storyhome"];
    } 
    $storynum = (empty($storynum) || $storynum > 50) ? 10 : intval($storynum);
    $storynum = ceil($storynum / $pagecols) * $pagecols;
    $colwidth = ceil(100 / $pagecols);
    $numpages = ceil($allstories / $storynum);
    $pagenum = intval($pagenum);
    $pagenum = ($pagenum < 1) ? 1 : $pagenum;
    $pagenum = ($pagenum > $numpages) ? $numpages : $pagenum;
    $offset = ($pagenum-1) * $storynum ;

    $qry = "SELECT s.sid, s.informant, s.title, s.hometext, s.bodytext, s.comments, s.counter, s.notes, s.time, s.alanguage, s.acomm, s.aid, s.score, s.ratings, s.topic, t.topicname, t.topicimage, t.topictext, c.catid, c.title AS cattitle, a.url, a.email
			FROM ((${prefix}_stories AS s
			LEFT JOIN ${prefix}_stories_cat AS c ON s.catid = c.catid) 
			LEFT JOIN ${prefix}_topics AS t ON s.topic = t.topicid) 
			LEFT JOIN ${prefix}_authors AS a ON s.aid = a.aid
			WHERE " . $where . "
			ORDER BY s.time DESC, s.sid DESC 
			LIMIT " . $offset . "," . $storynum . ";";
    $result = sql_query($qry);

    $storiecount = 0;
    $cattext = '';
    while ($stories[$storiecount] = sql_fetch_assoc($result)) {
        if (!empty($catid) && $storiecount == 0) {
            $cattext = $stories[$storiecount]["cattitle"];
        } 
        $storiecount++;
    } 

    if (empty($storiecount)) {
        $msg = "<br><br><b>" . _NOINFO4TOPIC . "</b><br><br>[&nbsp;<a href=\"modules.php?name=News\">" . _GOTONEWSINDEX . "</a>&nbsp;]";
        mxMessageScreen($msg);
        die();
    } 

    $pagetitle = _NEWSCATEGORY . ': ' . $cattext;
    if ($pagenum > 1) {
        $pagetitle .= ', ' . _NEWS_PAGE . ' ' . $pagenum;
    } 
    include("header.php");
    if (!empty($storiecount)) {
        $linkadd = "&amp;file=categories&amp;catid=" . $catid;
        if ($numpages > 1) {
            vkpShowPageLinks($numpages, $pagenum, $storynum, $allstories, $linkadd, $cattext);
        } else {
            title($cattext);
        } 
        sql_query("update ${prefix}_stories_cat set counter=counter+1 where catid=" . intval($catid));
        $i = 0;
        if ($pagecols > 1) {
            echo "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr valign=\"top\">";
        } 
        foreach($stories as $index => $story) {
            if (!is_array($story)) continue;
            $story = vkpGetStoryDetails($story);
            $story["title_formated"] = $story["title"]; /// Titel wieder zuruecksetzen ohne Kategorie
            $i++;
            if ($pagecols > 1) {
                if ($i == 1) {
                    echo "<tr valign=\"top\">";
                } 
                echo "<td width=\"" . $colwidth . "%\">";
                $story['column'] = $i;
            } else {
                $story['column'] = 1;
            } 
            themeindex($story["aid"], $story["informant"], $story["datetime"], $story["title_formated"], $story["counter"], $story["topic"], $story["hometext"], $story["notes"], $story["morelink"], $story["topicname"], $story["topicimage"], $story["topictext"], $story);
            if ($pagecols > 1) {
                echo "</td>";
                if ($i == $pagecols) {
                    echo "</tr>";
                    $i = 0;
                } 
            } 
        } 
        if ($pagecols > 1) {
            if ($i) {
                $colspan = $pagecols - $i;
                echo "<td colspan=\"" . $colspan . "\">&nbsp;</td></tr>";
            } 
            echo "</table>";
        } 
        echo "<br>";
        vkpShowPageLinks($numpages, $pagenum, $storynum, $allstories, $linkadd);
    } 
    include("footer.php");
} 

newscatindex($catid);

?>
